"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getEmitterAddressNear = exports.getEmitterAddressXpla = exports.getEmitterAddressInjective = exports.getEmitterAddressTerra = exports.getEmitterAddressSolana = exports.getEmitterAddressEth = void 0;
const bech32_1 = require("bech32");
const bytes_1 = require("@ethersproject/bytes");
const wormhole_1 = require("../solana/wormhole");
const utils_1 = require("../utils");
const ethers_1 = require("ethers");
function getEmitterAddressEth(contractAddress) {
    return Buffer.from((0, bytes_1.zeroPad)((0, bytes_1.arrayify)(contractAddress), 32)).toString("hex");
}
exports.getEmitterAddressEth = getEmitterAddressEth;
function getEmitterAddressSolana(programAddress) {
    return (0, wormhole_1.deriveWormholeEmitterKey)(programAddress).toBuffer().toString("hex");
}
exports.getEmitterAddressSolana = getEmitterAddressSolana;
function getEmitterAddressTerra(programAddress) {
    return __awaiter(this, void 0, void 0, function* () {
        return Buffer.from((0, bytes_1.zeroPad)(bech32_1.bech32.fromWords(bech32_1.bech32.decode(programAddress).words), 32)).toString("hex");
    });
}
exports.getEmitterAddressTerra = getEmitterAddressTerra;
exports.getEmitterAddressInjective = getEmitterAddressTerra;
exports.getEmitterAddressXpla = getEmitterAddressTerra;
function getEmitterAddressNear(programAddress) {
    return (0, utils_1.uint8ArrayToHex)((0, bytes_1.arrayify)((0, ethers_1.sha256)(Buffer.from(programAddress, "utf8"))));
}
exports.getEmitterAddressNear = getEmitterAddressNear;
